#include "lan.h"

unsigned char *pA0Pulse    = (unsigned char*)CS8900A_BASE;
unsigned char *pAdd        = (unsigned char*)CS8900A_BASE;
unsigned short *pAdd16     = (unsigned short*)CS8900A_BASE;


void InitLAN()
{
  BWC_bit.IO01BW = 0x2;            // bus width : 16bits
  //IO01AC_bit.IO01TYPE = 0x2; 	    // SCLK lenght for read end write
  //IO01AC_bit.IO01TYPE = 0x5;       //SCLK lenght for read end write
  IO01AC_bit.IO01TYPE = 0x7;       //SCLK lenght for read end write
}


void WriteWord(unsigned long Add, unsigned short uiData)
{
  //write
  pAdd = (unsigned char*)(CS8900A_BASE+Add);
  *pAdd = uiData;
  ++pAdd;
  *pAdd = uiData>>8;
}

unsigned short ReadWord(unsigned long Add)
{
  unsigned short Data;
  pAdd = (unsigned char*)(CS8900A_BASE+Add);
  Data = *pAdd;
  Data |= ((*++pAdd) << 8);
  return(Data);
}


void WriteWord16(unsigned long Add, unsigned short uiData)
{
  //pulse for A0 -> go to 16 byte mode
  ++pA0Pulse;
  *pA0Pulse = 0x0;
  --pA0Pulse;

  //write
  pAdd16 = (unsigned short*)(CS8900A_BASE+Add);
  *pAdd16 = uiData;
}

unsigned short ReadWord16(unsigned long Add)
{
  //pulse for A0 -> go to 16 byte mode
  ++pA0Pulse;
  *pA0Pulse = 0x0;
  --pA0Pulse;

  pAdd16 = (unsigned short*)(CS8900A_BASE+Add);
  return *pAdd16;
}

unsigned char TestLAN() {

  unsigned char state_lan = 0;
  unsigned short Data16 = 0x0;

  Data16 = 0x0;
  WriteWord16(0xA,0x0);
  Data16 = ReadWord16(0xC);
  if(Data16 != 0x630E) state_lan = 1;

  Data16 = 0x0;
  WriteWord16(0xA,0x2);
  Data16 = ReadWord16(0xC);
  if(Data16 != 0x0A00) state_lan = 1;

  return state_lan;
}

